/*
	csbord.c

	pmcm  1/10/90

	% CUA border portion of the C-scape Demo.

	C-scape 4.0 Demo Program
	Copyright (c) 1992 by Liant Software Corporation.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	01/10/90 pmcm	initialized radio fields and shadow field
	01/17/90 pmcm	fixed and added letter support for shadow yes/no field
	01/17/90 pmcm	added demo_ClipMoveToParent for bordersed
	01/23/91 pmcm	turned off BD_RESIZE for bordersed borders
	
	01/04/92 pmcm	revised for new bd_cua demo screen.

	01/15/92 pmcm	added some oak_notused()'s for to quiet warnings.
	06/08/92 pmcm	removed demo of standard borders; added sysbox menu.
	06/16/92 pmcm	changed features local var from int to long
*/

#include "csdemo.h"
#include "oakalloc.h"		/* 	for ocalloc */
#include "popdecl.h"		/*	for popups */

/* -------------------------------------------------------------------------- */
typedef struct _bddemo {
	unsigned int  *fdata;
	boolean 	   initialized;
} bddemo_struct, *bddemo_type;
	
/*	Border Demo auxiliary messages */
#define BDCUADEMOA_GETFIELDDATA 	AUX_USER(0)
					
/*	Border Demo Key Scancodes */
#define BDCUADEMOK_UPDATEVAR		KEY_USER(0)

/* -------------------------------------------------------------------------- */
boolean demo_Borders(void)
/*
 *	Demonstrates the C-scape bd_cua CUA-style border.
 */
{
	demo_LoadSed("bdcuaDemo", 
		DL_PAINT | DL_CENTER | DL_GO | DL_CLOSE | DL_ESCBTN | DL_HELPBTN | DL_MEMOUT);

	return(TRUE);
}

/* -------------------------------------------------------------------------- */
int aux_bdcuaDemo(sed_type sed, int msg, VOID *indata, VOID *outdata)
/*
 * 	Auxiliary function for the bdcuaDemo screen.
 *
 *	Initializes field variables to reflect the state of our border.
 *	Builds field-to-featuremask map and handles request for data.
 */
{
	boolean			torf;
	unsigned long 	features;
	int				i;
	bddemo_struct  *data;

	switch(msg) {

	case SED_PRESENTER:
		/*	initialize the field variables so they  reflect the state 
		 *	of the border on the test screen.
		 */

		/*	border item */
		torf = (win_GetBorderFunc(sed) == (bd_fptr) FNULL) ?  FALSE : TRUE;
		sed_SetNameVarValue(sed, "border", (VOID *)&torf);
	
		/*	border feature items */
		features = bord_GetFeature(sed);
	
		torf = (features & BD_TITLE) ? TRUE : FALSE;
		sed_SetNameVarValue(sed, "title", (VOID *)&torf);
	
		torf = (features & BD_PROMPT) ? TRUE : FALSE;
		sed_SetNameVarValue(sed, "prompt", (VOID *)&torf);
	
		torf = (features & BD_MOVE) ? TRUE : FALSE;
		sed_SetNameVarValue(sed, "move", (VOID *)&torf);
	
		torf = (features & BD_RESIZE) ? TRUE : FALSE;
		sed_SetNameVarValue(sed, "resize", (VOID *)&torf);
	
		torf = (features & BD_HZSCROLL) ? TRUE : FALSE;
		sed_SetNameVarValue(sed, "hzscroll", (VOID *)&torf);
	
		torf = (features & BD_VTSCROLL) ? TRUE : FALSE;
		sed_SetNameVarValue(sed, "vtscroll", (VOID *)&torf);
	
		torf = (features & BD_OUTLINE) ? TRUE : FALSE;
		sed_SetNameVarValue(sed, "outline", (VOID *)&torf);
	
		torf = (features & BD_MAXMIN) ? TRUE : FALSE;
		sed_SetNameVarValue(sed, "maxmin", (VOID *)&torf);

		torf = (features & BD_SYSBOX) ? TRUE : FALSE;
		sed_SetNameVarValue(sed, "sysbox", (VOID *)&torf);
		
		break;

	case AUX_START:
		if ((data = (bddemo_struct *) omalloc(OA_NOTAG, 
			sizeof(bddemo_struct))) != (bddemo_struct *) NULL) {

			data->fdata = (unsigned int *)NULL;
			data->initialized = FALSE;
		}
		win_SetData(sed, (VOID *) data);
		break;

	case WINA_STARTGO:
		/*	allocate and initialize field data store 
		 *	do this only on the first go round 
		 */
		if ((data = (bddemo_struct *) win_GetData(sed)) != (bddemo_struct *) NULL
			&&	!data->initialized) {

			/*	allocate field data array */
			if ((data->fdata = (unsigned int *) ocalloc(OA_NOTAG, 
				(SIZE_T) sed_GetFieldCount(sed), 
				sizeof(unsigned int))) != (unsigned int *) NULL) {
	
				/*	map field number to field data 
				 *	(data is border feature mask)
				 */

				for (i = 0; i < sed_GetFieldCount(sed); i++) {
					if 		(sed_IsFieldName(sed, i, "title")) {
						data->fdata[i] = BD_TITLE;
					}
					else if (sed_IsFieldName(sed, i, "prompt")) {
						data->fdata[i] = BD_PROMPT;
					}
					else if (sed_IsFieldName(sed, i, "move")) {
						data->fdata[i] = BD_MOVE;
					}
					else if (sed_IsFieldName(sed, i, "resize")) {
						data->fdata[i] = BD_RESIZE;
					}
					else if (sed_IsFieldName(sed, i, "outline")) {
						data->fdata[i] = BD_OUTLINE;
					}
					else if (sed_IsFieldName(sed, i, "vtscroll")) {
						data->fdata[i] = BD_VTSCROLL;
					}
					else if (sed_IsFieldName(sed, i, "hzscroll")) {
						data->fdata[i] = BD_HZSCROLL;
					}
					else if (sed_IsFieldName(sed, i, "maxmin")) {
						data->fdata[i] = BD_MAXMIN;
					}
					else if (sed_IsFieldName(sed, i, "sysbox")) {
						data->fdata[i] = BD_SYSBOX;
					}
					else {
					 	data->fdata[i] = 0;
					}
				}	/*	end field loop */
				data->initialized = TRUE;
			}
		}
		break;	/* case WINA_STARTGO */
		
	case BDCUADEMOA_GETFIELDDATA:
		if ((data = (bddemo_struct *) win_GetData(sed)) != (bddemo_struct *) NULL
			&&	data->initialized) {

			*(unsigned int *)outdata = data->fdata[*(unsigned int *)indata];
		}
		else {
			 *(unsigned int *)outdata = 0;
		}
		break;

	case AUX_END:
		if ((data = (bddemo_struct *) win_GetData(sed)) != (bddemo_struct *) NULL) {
			if (data->fdata != (unsigned int *) NULL) {
		 		ofree(OA_NOTAG, data->fdata);
			}
	 		ofree(OA_NOTAG, data);
		}
		break;

	default:
		break;
	}

	return(1);
}

/* -------------------------------------------------------------------------- */
boolean spc_bdcuaDemo(sed_type sed, int scancode)
/*
 *	Event handling for bdcuaDemo and bdcuaBorder screens.	
 */
{
	bd_fptr					bd;
	unsigned long			afeature;
	int						ret = FALSE;
	int						fldno;

	/*	normally, static data in special and auxiliary functions is a 
	 *	bad idea because it prevents windows from sharing the function.
	 *	here we use it because we know the function is used by a single
	 *	widow.
	 *	we need this data to remember the current features of border 
	 */
	static unsigned long 	features;

	fldno = sed_GetFieldNo(sed);

	/* treat spacebar as mouse click */
 	if (ascii(scancode) == ' ') {
		scancode = MOU_CLICK;
	}

	switch (scancode) {

	case ENTER:		
		/*	treat as MOU_CLICK, fall through */
	case MOU_CLICK:
		/*	note, the check_funcs field record and variable have yet to be
		 *	set.  so, if the variable is TRUE, then it is about to be
		 *	set FALSE; etc.
		 */
	
		if (win_GetBorderFunc(sed) != (bd_fptr) FNULL) {
			features = bord_GetFeature(sed);
		}

		if (sed_IsFieldName(sed, fldno, "border")) {
			bd = (*(boolean *)sed_GetVar(sed, fldno)) ?  (bd_fptr) FNULL: bd_cua;
			sed_SetBorder(sed, bd);

			if (bd != (bd_fptr) FNULL) {
				sed_SetBorderTitle(sed, demo_Text("auto_info"));
				sed_BorderPrompt(sed, (char *) sed_GetFieldData(sed, fldno, 0));
				bord_SetFeature(sed, features);
			}
			bord_Paint(sed);
		}
		else {
	   		/* one of the real (BD_) border features */
			sed_DoAux(sed, BDCUADEMOA_GETFIELDDATA, (VOID *)&fldno, (VOID *)&afeature);

			features = (*(boolean *) sed_GetVar(sed, fldno)) ? 
					   (features &= ~afeature) : (features |= afeature);

			if (sed_GetBorderFunc(sed) != (bd_fptr) FNULL) {
				bord_SetFeature(sed, features);
				bord_Paint(sed);
			}
		}	
		/*	stuff the event so that by the next event read the field
		 *	function will have updated the field record in accord with
		 *	this, the current event.  we depend on the updated record
		 *	contents for BDCUADEMOK_UPDATEVAR.
		 */
		kb_Stuff(BDCUADEMOK_UPDATEVAR);
		break;

	case BDCUADEMOK_UPDATEVAR:
		sed_DoFieldSexit(sed, fldno);
		ret = TRUE;
		break;

	case KEY_SYSBOX:
	case KEY_DSYSBOX:
	{
		/* 	Popup a menu when the user clicks or double-clicks
		 *	on CUA border SYSBOX button. 
		 */

 		opc_type	pc;
		int			ret;
		opcoord		left, top, right, bot;
		static char *win_sysbox_menu[] = {
			" Quit (ESC) ",
			NULL
		};

		if ((pc = opc_Open()) == NULL) {
			return(TRUE);
		}
		bord_GetPixSides(sed, &left, &top, &right, &bot);
		left -= bord_GetXmin(sed);
		top  -= bord_GetYmin(sed);
		opc_SetPixRow(pc, -top);
		opc_SetPixCol(pc, -left);
		opc_SetBorderFeature(pc, opc_GetBorderFeature(pc) & ~BD_MOVE);
		opc_SetBorderFeature(pc, opc_GetBorderFeature(pc) & ~BD_TITLE);

		oak_ClearAllocErrorTag(); 
		ret = opc_DoStrList(pc, win_sysbox_menu);
		if (oak_GetAllocErrorTag() != 0) {
			oak_ClearAllocErrorTag(); 
			demo_MemOut(demo_Text("memout"));
		}
		opc_Close(pc);

		switch (ret) {

		case 1:
			/* " Quit (ESC) " -- treat it like Escape */
			kb_Stuff(ESC);
			break;

		default:
			break;
		}	/*	end of SYSBOX menu choice switch */

		return(TRUE);

	}	/*	end of KEY_SYSBOX block */

	default:
		break;
	}	/*	end of scancode switch */

	return(ret);
}
/* -------------------------------------------------------------------------- */


