/*
	csinit.c

	pmcm  8/92

	% initialization and close code for the C-scape 4.0.1 Demo.

	C-scape 4.0.1 Demo Program
	Copyright (c) 1992 by Liant Software Corporation.
	ALL RIGHTS RESERVED.

	Revision History:
	-----------------
	 8/04/92 pmcm	split out from csdemo.c
	 8/05/92 pmcm	removed TEXTONLY, GRAFONLY

*/

#include "csdemo.h"
#include "framer.h"
#include "helpdecl.h"
#include "popdecl.h"
#include "oaktag.h"
#include "oakalloc.h"
#include "dpref.h"
#include "pmwinobj.h"
#include "ogldecl.h"

#ifdef OAK_DOS
#	include "pcmode.h"		 /* for pc_IsCompaqPlasma() and pc_IsHerc() */
#endif

/***------------------------- Module Globals -----------------------------***/

/* 	this is the symbol table for the demo screen file */

fsyminit_struct demo_list[] = {

	{FSYM_FIELDFUNCS },
	{"alpha_funcs",			FNULL, 			(VOID *) &alpha_funcs	},
	{"bob_funcs",			FNULL, 			(VOID *) &bob_funcs		},
	{"click_funcs",			FNULL, 			(VOID *) &click_funcs	},
	{"check_funcs",			FNULL, 			(VOID *) &check_funcs	},
	{"clong_funcs",			FNULL, 			(VOID *) &clong_funcs	},
	{"cmoney_funcs",		FNULL, 			(VOID *) &cmoney_funcs	},
	{"date_funcs",			FNULL, 			(VOID *) &date_funcs	},
	{"digit_funcs",			FNULL, 			(VOID *) &digit_funcs   },
	{"framer_funcs",		FNULL, 			(VOID *) &framer_funcs  },
	{"int_funcs",			FNULL, 			(VOID *) &int_funcs 	},
	{"mark_funcs",			FNULL, 			(VOID *) &mark_funcs	},
	{"menu_funcs",			FNULL, 			(VOID *) &menu_funcs	},
	{"nowrite_funcs", 		FNULL, 			(VOID *) &nowrite_funcs	},
	{"radio_funcs",			FNULL, 			(VOID *) &radio_funcs	},
	{"sint_funcs",			FNULL, 			(VOID *) &sint_funcs	},
	{"slug_funcs",			FNULL, 			(VOID *) &slug_funcs	},
	{"string_funcs",		FNULL, 			(VOID *) &string_funcs	},
	{"ted_funcs",			FNULL, 			(VOID *) &ted_funcs		},
	{"time_funcs",			FNULL, 			(VOID *) &time_funcs	},
	{"togint_funcs",		FNULL, 			(VOID *) &togint_funcs	},
	{"yesno_funcs",			FNULL, 			(VOID *) &yesno_funcs	},

	{FSYM_USER },
	{"age",					(VOID_FPTR)	age,					NULL },
	{"bdwalk",				(VOID_FPTR)	bdwalk,					NULL },
	{"vermont",				(VOID_FPTR)	vermont,				NULL },
	{"rent",				(VOID_FPTR)	rent,					NULL },
	{"robot",				(VOID_FPTR)	robot,					NULL },

	{FSYM_CLASS },
	{"sedwin_Class",		(VOID_FPTR) sedwin_Class, 			NULL },
	{"ufunc_Class",			(VOID_FPTR) ufunc_Class, 			NULL },

	{FSYM_BORDER },
	{"bd_cua",				(VOID_FPTR) bd_cua,					NULL },
	{"bd_box",				(VOID_FPTR) bd_box,					NULL },
	{"bd_123",				(VOID_FPTR) bd_123,					NULL },

	{FSYM_MOUSE },
	{"winmou_All",			(VOID_FPTR) winmou_All, 	  		NULL },
	{"sedmou_Click",		(VOID_FPTR) winmou_All, 			NULL },
	{"sedmou_GreedyTrack",	(VOID_FPTR) winmou_All, 			NULL },
	{"sedmou_Track",		(VOID_FPTR) winmou_All, 			NULL },
	{"sedmou_Framer", 		(VOID_FPTR) sedmou_Framer, 			NULL },

	{FSYM_MOVEMETHOD },

	{FSYM_EXPLODE },

	{FSYM_SPECIAL },		
	{"spc_bdcuaDemo", 		(VOID_FPTR) spc_bdcuaDemo,   		NULL },		
	{"spc_HelpButton",		(VOID_FPTR) spc_HelpButton, 		NULL },
	{"spc_BuySellBox",		(VOID_FPTR) spc_BuySellBox, 		NULL },
	{"spc_ClockMsg",		(VOID_FPTR) spc_ClockMsg,  			NULL },

	{"spc_List",			(VOID_FPTR) spc_List, 				NULL },
	{"spc_PriceBox",		(VOID_FPTR) spc_PriceBox, 			NULL },
	{"spc_Window",			(VOID_FPTR) spc_Window, 			NULL },

	{FSYM_AUX },
	{"aux_NoControl", 		(VOID_FPTR) aux_NoControl,   		NULL },
	{"aux_bdcuaDemo", 		(VOID_FPTR) aux_bdcuaDemo,   		NULL },
	{"aux_BuySellBox",		(VOID_FPTR) aux_BuySellBox, 		NULL },
	{"aux_CashBox",			(VOID_FPTR) aux_CashBox,   			NULL },
	{"aux_ClockMsg",		(VOID_FPTR) aux_ClockMsg,  			NULL },

	{"aux_Data1",			(VOID_FPTR) aux_Data1,  			NULL },
	{"aux_FileList", 		(VOID_FPTR) aux_FileList, 			NULL },
	{"aux_List",			(VOID_FPTR) aux_List,	 			NULL },
	{"aux_PriceBox",		(VOID_FPTR) aux_PriceBox,  			NULL },
	{"aux_Top",				(VOID_FPTR) aux_Top, NULL},
	{"aux_Window",			(VOID_FPTR) aux_Window,	 			NULL },

	{FSYM_LISTEND}
};

/* 	help data */
struct hx_struct hxd = { 0x13, 0x1e, 0x50, 0x13, bd_head};

/* ------------------------------------------------------------------------ */
/*	local prototypes */

OSTATIC int demo_Init(void);

/* ------------------------------------------------------------------------ */
int demo_Open(void)
/*
 * 	This routine opens the Demo by initializing the device interface 
 *	opening the help system and loading the principal Demo screens from
 *	the Demo screen file "csdemo.lnf".
 */
{
	FILE		*fp;
	scrn_struct *scrns;
	boolean 	do_mouse = TRUE;
	int			init_result;

	/* 	allocate memory cache to use when displaying the out-of-memory popup */

	if (!demo_AllocMemCache()) {
		return(DEMO_MEMCACHEFAIL);
	}

	/* 	initialize the device interface */
	if ((init_result = demo_Init()) != DEMO_NOFAIL) {
	 	return(init_result);
	}	

	/*	enable mouse support for the sed (Screen EDitor) window class */
	sedwin_MouseInit();

	/* 	initialize the random number sequence */
	srand(hard_Timer());

	/* 	give all the popups a shadow */
	popparms.shadow = 1;

	/* 	open the demo sfile */

	if ((demodata.demo_sfile = sfile_ReadOnly("csdemo.lnf", demo_list)) == NULL) {
		demo_FreeMemCache();
		disp_Close();
		oak_Close();
		return(DEMO_SFILEOPENFAIL);
	}

	/*	open and paint the background window, promptbar, and menubar. */

	if ((scrns = demo_OpenScrns()) == NULL) {
		demo_FreeMemCache();
		sfile_Close(demodata.demo_sfile);
		disp_Close();
		oak_Close();
		return(DEMO_SFILELOADFAIL);
	}

	if (demo_IsTextMode()) {
		demo_SetTextScrns(scrns);
		demo_SetCurrScrns(demo_GetTextScrns());
		demodata.textmode = TRUE;
	}
	else {
		demo_SetGrafScrns(scrns);
		demo_SetCurrScrns(demo_GetGrafScrns());
		demodata.textmode = FALSE;
	}

	/* 	turn on the mouse */
#ifdef OAK_DOS
	if (!demo_IsTextMode() && ogl_Ok() && pc_IsHerc()) {
		/*	forget the mouse under Herc graphics with OGL */
		do_mouse = FALSE;
	}
#endif

	if (do_mouse) {
		hard_InitMouse();
	}
	
	/* 	initialize mode, paint menu bar and buttons */
	demo_SetMode(MODE_MENU);

	/* display starting message */
	demo_LoadSed("StartUp", DL_CENTER | DL_PAINT | DL_GO | DL_CLOSE | DL_MEMOUT);

	if (!do_mouse) {
		demo_LoadSed("HercMouse", DL_PAINT | DL_GO | DL_CLOSE | DL_CENTER | DL_MEMOUT);
	}

	/* set up help system */
	if ((fp = fopen("csdemo.hlp", "rb")) != NULL) {
		if (help_Init(fp, help_Xref, 6000, (VOID *) &hxd) != HELP_OK) {
			demo_MemOut(demo_Text("helpmemout"));
		}
	}
	else {
		/* no help file, put up message */
		demo_FileMissing("csdemo.hlp");
	}

	return(DEMO_NOFAIL);
}
/* ------------------------------------------------------------------------ */

static int demo_Init(void)
/*
 *	Demo initialization for either character based or graphics display.
 *	Try graphics mode first.
 */
{

	if (!disp_Init(def_ModeGraphics, FNULL)) {
		if (!disp_Init(def_ModeText, FNULL)) {
			return(DEMO_INITFAIL);
		}
		else {
			demodata.textmode = TRUE;
			/*	no, we are not graphics capable */
			demodata.gcapable = FALSE;
		}
	}

	pmap_IoInit();
	bdcua_InitCombo();

	/*	this call looks at the hardware to determine whether or not to
	 *	set monochrome mode (command line flag will override) 
	 */
	demo_SetMono();

	/*	initial OGL only if we initialed graphics mode */
	if (!demo_IsTextMode() && ogl_Init(def_OGL)) {
		/*	
		 *	these are the 'system' colors used by the CUA style border.
		 *	although ogl_Init sets these, we reset them because
		 *	we have a command line monochrome option.
		 */
		if (demodata.mono) {
 			osys_InitSettings(&def_SysBwColors, TRUE);
		}
		else {
			osys_InitSettings(&def_SysColors, TRUE);
 		}
 	}

	/*	successful text-mode or graphics mode initialization */
	return(DEMO_NOFAIL);
}
/* ------------------------------------------------------------------------ */

boolean demo_SetMono(void)
{
	/* 	check for monochrome display */

#ifdef OAK_DOS
	if (demodata.usermono || disp_GetColors() <= 2L || pc_IsCompaqPlasma())
#else
	if (demodata.usermono || disp_GetColors() <= 2L)
#endif
	{
		disp_MapMono(TRUE);
		demodata.mono = TRUE;
		return(TRUE);
	}
	else {
		demodata.mono = FALSE;
		return(FALSE);
	}
}
/* ------------------------------------------------------------------------ */

boolean demo_SwitchToTextMode(void)
/*
 *	Switch back to text mode Device Interface from graphics mode.
 *
 *	Return FALSE if text mode is not supported.
 *
 *	Note: this routine assumes that it is called only when the current mode
 *	is a graphics display mode.
 */
{
	boolean	mouse_reinit = FALSE;	

#	ifdef OAK_DOS
	if (pc_IsHerc()) {
		/*	alwyas reinitialize the mouse under the Hercules card because
		 *	demo_ModeGraphics always turns it off.  (the mouse
		 *	is turned off to circumvent a conflict between OGL initialization
		 *	and hard_InitMouse.  at the time we call demo_ModeGraphics
		 *	we do not know that OGL is in use, so we always turn it off)
		 */
		mouse_reinit = TRUE;	
	}
#	endif

	/*	shutdown graphics */
	demodata.grafdisp = disp_GetCurrent();

	if (demodata.textdisp != NULL) {
		/*	we have been in text mode before.
		 *	put back the previously saved text mode interface.
		 */
		disp_SetCurrent(demodata.textdisp);

		if (mouse_reinit) {
			hard_InitMouse();
		}

		/* check for monochrome */
		demo_SetMono();
	}
	else {
		/* 	we are changing to text mode for the first time.
		 *	initialize the text mode device interface.
	     */
		if (!disp_Init(def_ModeText, FNULL)) {
			/* 	we cannot initialize, so restore the graphics mode */
			disp_SetCurrent(demodata.grafdisp);
			return(FALSE);
		}

#	ifdef OAK_DOS
		printf("\n csdemo: %s \n", demo_Text("init_textmode"));
#	endif

		/* check for monochrome */
		demo_SetMono();

		/*	turn on the mouse and intial the window mouse request handlers */
		hard_InitMouse();
		sedwin_MouseInit();
		pmwin_MouseInit();
		
		/*	create background window with promptbar, the menubar, and buttons */
		demo_SetTextScrns(demo_OpenScrns());

		if (demo_GetTextScrns() == NULL) { 
			/* 	we cannot load screens, so restore the graphics mode */
			demo_MemOut(SFILELOADFAIL_MSG);

			disp_Close();
			oak_Close();

	 		disp_SetCurrent(demodata.grafdisp);
			demo_SetCurrScrns(demo_GetGrafScrns());
			demodata.textmode = FALSE;
			return(FALSE);
		}
	}

	demodata.textmode = TRUE;

	demo_SetCurrScrns(demo_GetTextScrns());

	/* initialize mode, paint menu bar */
	demo_SetMode(MODE_MENU);

	return(TRUE);
}

/* ------------------------------------------------------------------------ */
boolean demo_SwitchToGraphicsMode(void)
/*
 *	Switch to graphics mode Device Interface.
 *	Return FALSE if graphics mode is not supported.
 *
 *	Note: this routine assumes that it is called only when the current mode
 *	is a text display mode.
 */
{
	boolean mouse_reinit = FALSE;

#	ifdef OAK_DOS
	if (demo_IsTextMode() && pc_IsHerc()) {
	 	/*	turn the mouse off under Herc in case we go to graphics
		 *	with OGL 
		 */
	 	hard_DeInitMouse();
	 	mouse_reinit = TRUE;
	}
#	endif

	/* 	save a pointer to the text interface and shut it down. */
	demodata.textdisp = disp_GetCurrent();

	if (demodata.grafdisp != NULL) {
		/*	we have been in graphics mode before.
		 *	put back the previously saved graphics interface.
		 */
   		disp_SetCurrent(demodata.grafdisp);
		
#	ifdef OAK_DOS
		if (pc_IsHerc()) {
			if (mouse_reinit && !ogl_Ok()) {
				/*	 use the mouse under Herc graphics only if no OGL */
			hard_InitMouse();
			}
		}
		else if (mouse_reinit) {
			hard_InitMouse();
		}
#	endif

		/* check for monochrome */
		demo_SetMono();
	}
	else {
		/* 	we are changing to graphics mode for the first time.
		 *	initialize the graphics mode device interface.
		 * 	def_ModeGraphics selects best available graphics mode.
	     */

		if (!disp_Init(def_ModeGraphics, FNULL)) {
			/* 	we cannot initialize, so restore the text mode */
			disp_SetCurrent(demodata.textdisp);
	
			if (mouse_reinit) {
			 	hard_InitMouse();
			}
			return(FALSE);
		}

#	ifdef OAK_DOS
		if (!pc_IsHerc()) {
			printf("\n csdemo: %s \n", demo_Text("init_grafmode"));
		}
#	endif

		/* check for monochrome */
		demo_SetMono();

		if (ogl_Init(def_OGL)) {
			if (demodata.mono) {
	 			osys_InitSettings(&def_SysBwColors, TRUE);
			}
			else {
				osys_InitSettings(&def_SysColors, TRUE);
	 		}
	 	}

		sedwin_MouseInit();
		pmwin_MouseInit();
		
		/* 	turn on pmap window .pcx file handling */
		pmap_IoInit();

		/*	create background window with promptbar, the menubar, and buttons */
		demo_SetGrafScrns(demo_OpenScrns());

		if (demo_GetGrafScrns() == NULL) { 
			/* 	we cannot load screens, so restore the text mode */
			demo_MemOut(SFILELOADFAIL_MSG);

			disp_Close();
			oak_Close();

	 		disp_SetCurrent(demodata.textdisp);
			if (mouse_reinit) {
			 	hard_InitMouse();
			}
			demo_SetCurrScrns(demo_GetTextScrns());
			demodata.textmode = TRUE;
			return(FALSE);
		}

		/* 	turn on the mouse */
#	ifdef OAK_DOS
		if (ogl_Ok() && pc_IsHerc()) {
			/*	forget the mouse under Herc graphics with OGL */
			demo_LoadSed("HercMouse", DL_PAINT | DL_GO | DL_CLOSE | DL_CENTER | DL_MEMOUT);
		}
		else {
			hard_InitMouse();
		}
#	else
		hard_InitMouse();
#	endif

	}

	demodata.textmode = FALSE;

	demo_SetCurrScrns(demo_GetGrafScrns());

	/* initialize mode, paint menu bar */
	demo_SetMode(MODE_MENU);

	return(TRUE);
}

/* ------------------------------------------------------------------------ */
void demo_Close(void)
/*
	Close down the display interface(s)
*/
{
	/* 	close out help system */
	help_Close();

#ifndef DEMO_CLEANCLOSE
	/*	we do not have to worry about exit in a particular mode if we
	 *	have two display manager and we do not have to explicitly free
	 *	a bunch o' stuff 
	 */

	/*	wipe the display clear */
	disp_Clear(0x70);

	/*	close the current display manager and, if present, OGL */
	disp_Close();

#else
	/*	clean close--exit in the right display mode and make sure we
	 *	free everything. 
	 */

	if (demo_IsGraphicsCapable()) {
		if (demo_IsTextMode()) {
			/* 	switch to back to graphics mode.
	 		 * 	(we need to exit in graphics mode because that is the
			 * 	mode i which we started.  I.e., the first display manager
			 * 	has the record of the mode to restore when the application
			 * 	exits.)
			 */
			demo_SwitchToGraphicsMode();
		}
	
		if (demodata.textdisp != NULL) {
			 /*	switch to text mode and close that display manager */
			demo_SwitchToTextMode();
	
			/*	clear display
			 * 	close menubar,promptbar,backdrop,and buttons
			 *	close the device interface
			 */
			disp_Clear(0x70);
			demo_CloseScrns();
			disp_Close();
	
			/*	free up internal object name lists */
			oak_Close();
	
			/* 	switch back to graphics mode. */
	 		disp_SetCurrent(demodata.grafdisp);
			demo_SetCurrScrns(demo_GetGrafScrns());
			demodata.textmode = FALSE;
		}
	}

	/*	clear display
	 * 	close menubar,promptbar,backdrop,and buttons
	 *	close the device interface
	 */
	disp_Clear(0x70);
	demo_CloseScrns();
	disp_Close();
	
	/*	free up internal object name lists */
	oak_Close();

	/*	free up the out-of-memory stash */
	demo_FreeMemCache();
#endif
	return;
}
/* ------------------------------------------------------------------------ */
