/*
	cswrld.c

	jmd 6/90

	% C-scape Order Information portion of the C-scape Demo.

	C-scape 4.0 Demo Program
	Copyright (c) 1992 by Liant Software Corporation.
	ALL RIGHTS RESERVED.

	OVERVIEW:
	---------

	Revision History:
	-----------------
	 8/24/90 pmcm	changed SED_LASTMSG to 	SEDWM_LASTMSG, and
					changed WINA_GO 	to 	WINA_STARTGO
	11/24/90 jmd	moved to demo
	 1/24/91 pmcm	changed sed_SetMouseCode to kb_Stuff
	 2/01/91 pmcm	move map prompt update from spc to aux to fixed off by one
	 4/02/91 bkd	adapted to new pmap color method
	 4/03/91 bkd	fixed typo in new color code, added void to arglist
	 4/03/91 bkd	added "void" to empty argument lists
	 7/03/91 bkd	updated to final 3.2c format (new pmap method).
	 7/17/91 bkd	added sensitivity to DEMO_TEXTONLY

	 1/02/92 pmcm	bd_cua'd
	 3/06/92 pmcm	changed mouse handlers to winmou_All
	 6/08/92 pmcm	updated map aux func to use default aux; added MOU_NOFIELD
	 6/16/92 pmmc	added error checks; removed obsolete NoMapMsg screen.
	 7/20/92 mla	changed sed_Find() to obj_Find()
*/

#include "csdemo.h"

#include "pmwinobj.h"		/* for pmwin stuff */

/***------------------------ Local Function Declaration Prototypes -------***/

void 		about(sed_type sed);
void 		demo_WorldInitRegions(void);
char   	   *find_region(opcoord x, opcoord y);

aux_func   (aux_World);

/***------------------------ Logicals ------------------------------------***/

/* 	define our own auxiliary messages */
#define  COUNTRYSED_FIND		AUX_USER(0)
#define  COUNTRYSED_SELECT		AUX_USER(1)

/***------------------------- Module Globals -----------------------------***/

typedef struct _geobox {

	char   *name;			/* name of the region */

	opcoord	xmin;			/* extent of the region */
	opcoord	ymin;
	opcoord	xmax;
	opcoord	ymax;

} geobox;

geobox regions[] = {

	/* 	the name members of this list are initialized from the demo sfile
	 * 	by demo_WorldInitRegions().  The correspondence between a member's 
	 *	list position and its name is hard-coded.
	 */

	{NULL,			 	18,  85,  26,  90 },			/* North America 	*/
	{NULL,			 	 7,  30,  47,  61 },			/* North America 	*/
	{NULL,			 	47,  30, 111,  87 },			/* North America 	*/
	{NULL,			 	47,   8, 147,  30 },			/* North America 	*/
	{NULL, 			   111,  30, 138,  51 },			/* North America 	*/
	{NULL,			   	68,  87, 104,  99 },			/* North America 	*/

	{NULL,			 	87,  99, 131, 163 },			/* South America 	*/

	{NULL,		  	   137,  40, 146,  46 },			/* Europe 			*/
	{NULL,		  	   146,  49, 183,  74 },			/* Europe 			*/
	{NULL,		  	   162,  32, 183,  49 },			/* Europe 			*/

	{NULL,	  		   177,  74, 213, 100 },			/* Middle East 		*/

	{NULL,		  	   139,  74, 177, 107 },			/* Africa 			*/
	{NULL,		  	   160, 107, 201, 145 },			/* Africa 			*/
	{NULL,		  	   177, 100, 201, 107 },			/* Africa 			*/

	{NULL,		  	   183,  23, 213,  74 },			/* Asia 			*/
	{NULL,		  	   213,  13, 283,  86 },			/* Asia 			*/
	{NULL,		  	   283,  31, 322,  64 },			/* Asia 			*/
	{NULL,		  	   213,  86, 269, 119 },			/* Asia 			*/
	{NULL,		  	   269, 112, 288, 123 },			/* Asia 			*/

	{NULL,	  		   252, 123, 288, 157 },			/* Australia 		*/
	{NULL,	  		   294, 142, 308, 160 },			/* Australia 		*/

	{NULL,			     0,  30, 104, 200 },			/* Pacific Ocean 	*/
	{NULL,			   104,  30, 177, 200 },			/* Atlantic Ocean 	*/
	{NULL,   		   177,  30, 269, 200 },			/* Indian Ocean 	*/
	{NULL, 			   269,  30, 400, 200 },			/* Pacific Ocean 	*/
	{NULL,				 0,   0, 400,  30 },			/* Arctic Ocean 	*/

	{NULL,				 0,   0, 400, 200 },			/* Ocean 			*/

	{NULL, 0, 0, 0, 0}
};

/* ------------------------------------------------------------------------ */
void demo_WorldInitRegions(void)
/*
 *	Initialize the name of the regions from the screen file.
 *
 *		0 -  5	North America
 *  	     6 	South America
 *  	7 -  9	Europe
 *  	   	10 	Middle East
 *     11 - 13  Africa
 *     14 - 18  Asia
 *	   19 - 20 	Australia	
 *			21	Pacific Ocean
 * 			22	Atlantic Ocean
 *			23	Indian Ocean
 *			24	Pacific Ocean
 *			25	Arctic Ocean
 *			26	Ocean
 */
{
	int		i;
	char 	*s;

 	for (s = demo_Text("north_america"), i =  0; i <=  5; regions[i++].name = s);

 	regions[6].name  = demo_Text("south_america");

 	for (s = demo_Text("europe"), i = 7; i <=  9; regions[i++].name = s);

 	regions[10].name = demo_Text("middle_east");

 	for (s = demo_Text("africa"), i = 11; i <= 13; regions[i++].name = s);
 	for (s = demo_Text("asia"), i = 14; i <= 18; regions[i++].name = s);
 	for (s = demo_Text("australia"), i = 19; i <= 20; regions[i++].name = s);

 	regions[21].name = demo_Text("pacific_ocean");
 	regions[22].name = demo_Text("atlantic_ocean");
 	regions[23].name = demo_Text("indian_ocean");
 	regions[24].name = demo_Text("pacific_ocean");
 	regions[25].name = demo_Text("arctic_ocean");
 	regions[26].name = demo_Text("ocean");

	return;
}

/* ------------------------------------------------------------------------ */
boolean demo_World(void)
/*
	Create the world map and other windows.

	Returns FALSE if it can't find the .pcx files
*/
{
	ocbox 	  	cbox;
	FILE 	   *fp;
	sed_type  	clistsed= NULL;
	sed_type 	msgsed 	= NULL;
	win_type  	mapwin 	= NULL;
	pmap_type 	pmap 	= NULL;

	if ((msgsed = demo_LoadSed(demo_IsTextMode() ? "WorldMsgText" : "WorldMsgGraf", DL_PAINT)) == NULL) {
		return(FALSE);
	}

	if (!demo_IsTextMode()) {
		/* 	graphics mode, load the map of the world */

		if ((fp = fopen("cswrld.pcx", "rb")) == NULL) {
			demo_FileMissing("cswrld.pcx");
			win_Close(msgsed);
			return(FALSE);
		}
		if ((pmap = pmap_Load(fp, def_PmapFilePCX)) == NULL) {
			fclose(fp);
			win_Close(msgsed);
			return(FALSE);
		}
		fclose(fp);

		/* prepare the image for display */
		if (!pmap_DispLoad(pmap)) {
			pmap_Close(pmap);
			win_Close(msgsed);
			return(FALSE);
		}

		/* create the world window */
		/* first define the size of the windows in a ocbox structure: */
		cbox.toprow   = 3;
		cbox.leftcol  = 24;
		cbox.botrow   = cbox.toprow + 10;
		cbox.rightcol = cbox.leftcol + 40;

		/* 
			now create the window with win_Open.  We pass win_Open
		   	the class function for the type of window we wish to create,
		   	in this case pmwin_Class, and a pointer to the ocbox structure
		   	defining its initial size and position.
		*/	

		if ((mapwin = win_Open(pmwin_Class, &cbox)) == NULL) {
			pmap_Close(pmap);
			win_Close(msgsed);
			return(FALSE);
		}

		win_SetAttr(mapwin, 0xf3);
		win_SetShadowAttr(mapwin, 0x11);
		if (!win_SetBorder(mapwin, bd_cua)) {
			win_Close(mapwin);
			pmap_Close(pmap);
			win_Close(msgsed);
			return(FALSE);
		}

		win_SetShadow(mapwin, 1);
		bord_SetFeature(mapwin, BD_PROMPT | BD_MOVE | BD_OUTLINE | BD_RESIZE);

		obj_SetAux(mapwin, aux_World);
		win_SetMouse(mapwin, winmou_All);

		/* attach the pmap to the pmap window */
		pmwin_SetPmap(mapwin, pmap);

		/* Name the mapwin */
		obj_SetName(mapwin, "MapWin");

		/*	init the texts of the regions structure if loading from sfile */
		demo_WorldInitRegions();

		win_Employ(mapwin);
	}

	/* 	load the menu list of countries */
	if ((clistsed = demo_LoadSed("CountryList", DL_PAINT)) == NULL) {
		win_Close(clistsed);
		win_Close(msgsed);

		if (mapwin != NULL) {
			win_Close(mapwin);
		}
		return(FALSE);
	}

	demo_SetButtonData(HELPBTN, (VOID *) clistsed);
	demo_ShowButton(HELPBTN);
	demo_ShowButton(ESCBTN);

	sed_Go(clistsed);

	demo_SetButtonData(HELPBTN, NULL);
	demo_HideButton(HELPBTN);
	demo_HideButton(ESCBTN);

	/* close the windows */
	sed_Close(msgsed);
	sed_Close(clistsed);

	if (mapwin != NULL) {
		win_Close(mapwin);
	}

	/* close the pmap */
	if (pmap != NULL) {
		pmap_Close(pmap);
	}

	return(TRUE);
}

/* ------------------------------------------------------------------------ */
boolean spc_List(sed_type sed, int scancode)
/*
	The special function for the country list sed.
*/
{
	char 	*fname;

	fname = sed_GetFieldName(sed, sed_GetFieldNo(sed));
	if (fname != NULL && strcmp("quit", fname) != 0) {

		switch(scancode) {
		case MOU_CLICK:
		case ENTER:
			/* Send a SELECT message to our Aux function */
			sed_DoAux(sed, COUNTRYSED_SELECT, (VOID *)fname, NULL);
			return(TRUE);

		default:
			break;
		}
	}
	return(FALSE);
}

/* ------------------------------------------------------------------------ */
int aux_List(sed_type sed, int msg, VOID *indata, VOID *outdata)
/*
	An auxiliary function for the country list sed.
*/
{
	int 	 fldno;
	byte 	 reg, sel, back;
	win_type mapwin;
	char 	*fname;

	oak_notused(outdata);

	switch(msg) {
	case SED_POSTFENTER:
		/* update the prompt in the mapwin */
		if ((fname = sed_GetFieldName(sed, sed_GetFieldNo(sed))) != NULL &&
			strcmp("quit", fname) != 0									 &&
			(mapwin = obj_Find("MapWin")) != NULL) 							{

			bord_SendMsg(mapwin, BDM_PROMPT, (VOID *) fname, NULL);
		}
		break;

	case COUNTRYSED_FIND:
		/* find (and go to) the field specified by indata 
		 *  (indata is a char * pointing to a country name
		 */
		if (indata == NULL || 
			(fldno = sed_GetNameNo(sed, (char *) indata)) < 0) {

			/* didn't find the region */
			break;
		}
		else {
			sed_UnMarkField(sed, sed_GetFieldNo(sed));
			sed_GotoField(sed, fldno);
			sed_GetColors(sed, &reg, &back, &sel);
			sed_MarkField(sed, sed_GetFieldNo(sed), sel, sel);
			sed_UpdateCurrField(sed);
		}
		/* no break; fall through to SELECT message */

	case COUNTRYSED_SELECT:
		/* popup the country information box from the screen file:
		 *  (indata is a char * pointing to a country name
		 */
		demo_HideButton(HELPBTN);
		demo_HideButton(ESCBTN);
		demo_LoadSed((char *) indata, DL_PAINT | DL_GO | DL_CLOSE | DL_MEMOUT);
		demo_ShowButton(HELPBTN);
		demo_ShowButton(ESCBTN);
		break;

	case WINA_STARTGO:
		/* we're active: unmark any marked fields */
		for (fldno = 0; fldno < sed_GetFieldCount(sed); fldno++) {
			if (sed_IsMarkedField(sed, fldno)) {
				sed_UnMarkField(sed, fldno);
				sed_UpdateField(sed, fldno);
			}
		}
		break;

	case SED_POSTSEXIT:
		/* we're unactive: mark the current field */
		sed_GetColors(sed, &reg, &back, &sel);
		sed_MarkField(sed, sed_GetFieldNo(sed), sel, sel);
		sed_UpdateCurrField(sed);
		break;

	default:
		break;
	}

	return(1);
}

/* ------------------------------------------------------------------------ */
int aux_World(win_type win, int msg, VOID *indata, VOID *outdata)
/*
	An auxiliary function for the map window.

	This function gets called when we call win_Go on the map window.
	It handles the character and mouse input.
	(similar to a C-scape fkey function)
*/
{
	mev_struct 	mev;			/* a mouse event structure */
	opcoord 	x, y;
	sed_type	country_sed;
	char	   *country;
	int			scancode;

	oak_notused(indata);
	oak_notused(outdata);

	/* find the country list sed */
	country_sed = obj_Find("CountryList");

	switch (msg) {
	default:
		break;

	case WINA_EVENT:
		switch ((scancode = *(int *) indata)) {
		case UP:  						
		case DOWN:
		case LEFT:	
		case RIGHT:
			/* pass control (and scancode) back to country list */
			if (country_sed != NULL) {
				kb_Stuff(scancode);
				win_SetNextWin(win, country_sed);
				/*	exit */
				return(BOB_ABORT);
			}
			break;

		case MOU_NOFIELD:
		case MOU_CLICK:
			/* figure out where the mouse was clicked */

			/* Get the current mouse event in a mev_struct */
			win_MouseCurrEvent(&mev);

			x = mev_GetX(&mev) + pmwin_GetXoffs(win);
			y = mev_GetY(&mev) + pmwin_GetYoffs(win);

			country = find_region(x,y);
			bord_SendMsg(win, BDM_PROMPT, country, NULL);

			/* Send an aux message to the country list sed */
			if (country_sed != NULL) {
				sed_DoAux(country_sed, COUNTRYSED_FIND, (VOID *) country, NULL);
			}
			/*  consume the event */
			return(1);

		default:
			break;
		}	/*	end of scancode switch */
	}	/*	end of message switch */

	return(aux_WinDefault(win, msg, indata, outdata));
}

/* ------------------------------------------------------------------------ */
char *find_region(opcoord x, opcoord y)
/*
	Return the name of the region (x, y) points to
	using the regions structure list,
*/
{
	int i;

	for (i = 0; regions[i].name != NULL; i++) {

		if (x >= regions[i].xmin && x < regions[i].xmax &&
			y >= regions[i].ymin && y < regions[i].ymax) {
			return(regions[i].name);
		}
	}

	return("not_found");
}
/* ------------------------------------------------------------------------ */
